﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr118_1
{
    // Класс с перегрузкой операторов сравнения == и != 
    // и переопределением методов GetHashCode() и Equals(): 
    class MyClass
    {
        // Целочисленное поле: 
        public int code;
        // Текстововое поле: 
        public string txt;
        // Конструктор с двумя аргументами: 
        public MyClass(int n, string t)
        {
            code = n; // Значение целочисленного поля
            txt = t;  // Значение текстового поля
        }

        // Перегрузка оператора "меньше": 
        public static bool operator <(MyClass a, MyClass b)
        {
            return a.txt.Length < b.txt.Length;
        }

        // Перегрузка оператора "больше": 
        public static bool operator >(MyClass a, MyClass b)
        {
            return a.txt.Length > b.txt.Length;
        }
        
        // Перегрузка оператора "меньше или равно": 
        public static bool operator <=(MyClass a, MyClass b)
        {
            if (a.code <= b.code) return true;
            else return false;
        }

        // Перегрузка оператора "больше или равно": 
        public static bool operator >=(MyClass a, MyClass b)
        {
            if (a.code >= b.code) return true;
            else return false;
        }
        
        // Переопределение метода GetHashCode():
        public override int GetHashCode()
        {
            // Вычисление хэш-кода: 
            return code ^ txt[0];
        }

        // Переопределение метода Equals():
        public override bool Equals(Object obj)
        {
            // Локальная объектная переменная:
            MyClass t = (MyClass)obj;
            // Результат метода:
            if (code == t.code && txt == t.txt)
                return true;
            else return false;
        }

        // Перегрузка оператора "равно": 
        public static bool operator ==(MyClass a, MyClass b)
        {
            // Вызов метода Equals():
            return a.Equals(b);
        }

        // Перегрузка оператора "не равно": 
        public static bool operator !=(MyClass a, MyClass b)
        {
            // Использование оператора "равно": 
            return !(a == b);
        }
    }

    // Класс с главным методом: 
    class Program
    {
        // Главный метод: 
        static void Main()
        {
            // Создание объектов:
            MyClass A = new MyClass(100, "A");
            MyClass B = new MyClass(100, "B");
            MyClass C = new MyClass(200, "A");
            MyClass D = new MyClass(100, "Aaa");
            MyClass E = new MyClass(100, "A");
            // Использование операторов строгого сравнения:
            Console.WriteLine("A<D дает {0}", A < D);
            Console.WriteLine("A>D дает {0}", A > D);
            Console.WriteLine("A<С дает {0}", A < C);
            Console.WriteLine("A>С дает {0}", A > C);
            // Использование операторов нестрогого сравнения:
            Console.WriteLine("А>=C дает {0}", A >= C);
            Console.WriteLine("А<=C дает {0}", A <= B);
            Console.WriteLine("B>=D дает {0}", B >= D);
            Console.WriteLine("B<=D дает {0}", B <= D);
            // Сравнение объектов на предмет 
            // равенства и неравенства:
            Console.WriteLine("А==В дает {0}", A == B);
            Console.WriteLine("А!=В дает {0}", A != B);
            Console.WriteLine("А==С дает {0}", A == C);
            Console.WriteLine("А!=С дает {0}", A != C);
            Console.WriteLine("A==D дает {0}", A == D);
            Console.WriteLine("A!=D дает {0}", A != D);
            Console.WriteLine("А==E дает {0}", A == E);
            Console.WriteLine("А!=E дает {0}", A != E);
            // Задержка:
            Console.ReadLine();
        }
    }
}
